#include <stdio.h>

class Matrix {
 public:
  int **c;
  int n,m;
  Matrix () : n(0), m(0) {};
  Matrix (int r=2);
  Matrix (int n0=2, int m0=2);
  Matrix (const Matrix &);
  ~Matrix();
  void operator = (Matrix &);
  void operator += (Matrix &);
  void operator -= (Matrix &);
  void operator *= (Matrix &);
  void operator += (int);
  void operator -= (int);
  void operator *= (int);
  Matrix operator + (Matrix &);
  Matrix operator - (Matrix &);
  Matrix operator * (Matrix &);
  Matrix operator + (int);
  Matrix operator - (int);
  Matrix operator * (int);
  int * operator [] (int i) { return c[i]; }
  void show (char *);
};

Matrix::Matrix (int r) {
 new Matrix (r,r);
}

Matrix::Matrix (int n0,int m0) {
 n=n0; m=m0;
 c= new int * [n];
 for (int i=0; i<n; i++)
  c[i]=new int [m];
}

Matrix::~Matrix () {
 for (int i=n-1; i>-1; i--) delete c[i];
 delete c;
}

void Matrix::operator = (Matrix &p) {
 n=p.n; m=p.m;
 for (int i=0; i<n; i++) for (int j=0; j<m; j++) c[i][j]=p.c[i][j];
}

Matrix::Matrix (const Matrix &p) {
 n=p.n; m=p.m;
 c= new int * [n];
 for (int i=0; i<n; i++) c[i]=new int [m];
 for (i=0; i<n; i++) for (int j=0; j<m; j++) c[i][j]=p.c[i][j];
}

Matrix Matrix::operator + (Matrix &p) {
 Matrix r=Matrix(n,m);
 int i,j;
 for (i=0; i<n; i++)
 for (j=0; j<m; j++) r.c[i][j]=c[i][j]+p.c[i][j];
 return r;
}

Matrix Matrix::operator - (Matrix &p) {
 Matrix r=Matrix(n,m);
 int i,j;
 for (i=0; i<n; i++)
 for (j=0; j<m; j++) r.c[i][j]=c[i][j]-p.c[i][j];
 return r;
}

Matrix Matrix::operator * (Matrix &p) {
 Matrix r=Matrix(n,p.m);
 int i,j,k;
 for (i=0; i<n; i++)
 for (j=0; j<p.m; j++) {
  r.c[i][j]=0;
  for (k=0; k<m; k++) r.c[i][j]+=c[i][k]*p.c[k][j];
 }
 return r;
}

Matrix Matrix::operator + (int p) {
 Matrix r=Matrix(n,m);
 int i,j;
 for (i=0; i<n; i++)
 for (j=0; j<m; j++) r.c[i][j]=c[i][j]+p;
 return r;
}

Matrix Matrix::operator - (int p) {
 Matrix r=Matrix(n,m);
 int i,j;
 for (i=0; i<n; i++)
 for (j=0; j<m; j++) r.c[i][j]=c[i][j]-p;
 return r;
}

Matrix Matrix::operator * (int p) {
 Matrix r=Matrix(n,m);
 int i,j;
 for (i=0; i<n; i++)
 for (j=0; j<m; j++) r.c[i][j]=c[i][j]*p;
 return r;
}

void Matrix::operator += (Matrix &p) {
 int i,j;
 for (i=0; i<n; i++)
 for (j=0; j<m; j++) c[i][j]+=p.c[i][j];
}

void Matrix::operator -= (Matrix &p) {
 int i,j;
 for (i=0; i<n; i++)
 for (j=0; j<m; j++) c[i][j]-=p.c[i][j];
}

void Matrix::operator *= (Matrix &p) {
 Matrix r=Matrix(p.n,p.m);
 for (int i=0; i<p.n; i++)
 for (int j=0; j<p.m; j++) {
  r.c[i][j]=0;
  for (int k=0; k<m; k++) r.c[i][j]+=c[i][k]*p.c[k][j];
 }
 for (i=0; i<p.n; i++)
 for (int j=0; j<p.m; j++) c[i][j]=r.c[i][j];
}

void Matrix::operator += (int p) {
 int i,j;
 for (i=0; i<n; i++)
 for (j=0; j<m; j++) c[i][j]+=p;
}

void Matrix::operator -= (int p) {
 int i,j;
 for (i=0; i<n; i++)
 for (j=0; j<m; j++) c[i][j]-=p;
}

void Matrix::operator *= (int p) {
 int i,j;
 for (i=0; i<n; i++)
 for (j=0; j<m; j++) c[i][j]*=p;
}

void Matrix::show (char *s) {
 puts (s);
 int i,j;
 for (i=0; i<n; i++) {
  for (j=0; j<m; j++) printf ("%d ",c[i][j]);
  printf ("\n");
 }
}

void main () {
 Matrix a(2,2);
 a[0][0]=1; a[0][1]=2;
 a[1][0]=3; a[1][1]=4;
 a.show ("  A" );
 Matrix b(2,2);
 b[0][0]=2; b[0][1]=0;
 b[1][0]=1; b[1][1]=3;
 b.show ("  B" );
 Matrix c=b+a;
 c.show ("C=B+A");
 Matrix d = a + 1;
 d.show ("D=A+1");
 Matrix e = a * b;
 e.show ("E=A*B");
 a*=2;
 a.show ("A*=2");
 b+=b;
 b.show ("B+=B");
 b-=b*2;
 b.show ("B-=B*2");
 d*=d;
 d.show ("D*=D");
}